#include <cassert>
#include <iostream>
#include <set>   

using namespace std;

typedef struct {
    int math;
    int it;
    int index;
    bool dead;
} stud_t;

struct less1 {
    bool operator() (stud_t a, stud_t b) {
        return a.math == b.math ? a.it > b.it : a.math > b.math;
    }
};

struct less2 {
    bool operator() (stud_t a, stud_t b) {
        return a.it == b.it ? a.math > b.math : a.it > b.it;
    }
};

int diff(stud_t num) {
    return abs(num.it - num.math);
}

struct less3 {
    bool operator() (stud_t a, stud_t b) {
        less1 comp;
        return diff(a) == diff(b) ? comp(a, b) : diff(a) < diff(b);
    }
};

multiset<stud_t, less1> first;
multiset<stud_t, less2> second;
multiset<stud_t, less3> third;

void assign_student(stud_t student) {
    first.erase(first.lower_bound(student));
    second.erase(second.lower_bound(student));
    third.erase(third.lower_bound(student));
}

template <class Compare>
void extract_from(multiset<stud_t, Compare>& _set) {
    stud_t tmp;
    if (!_set.empty()) {
        tmp = *_set.begin();
        cout << tmp.index << " ";
        assign_student(tmp);
    }
}

int main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int n;
    cin >> n;

    set<pair<int, int> > points;

    for(int i = 0; i < n; ++i) {
        stud_t tmp;
        cin >> tmp.math >> tmp.it;
        tmp.index = i + 1;
        first.insert(tmp);
        second.insert(tmp);
        third.insert(tmp);
        
        pair<int, int> pr = make_pair(tmp.math, tmp.it);
        assert(points.find(pr) == points.end());
        points.insert(pr);
    }

    while( !first.empty() || !second.empty() || !third.empty()) {
        extract_from<less1>(first);
        extract_from<less2>(second);
        extract_from<less3>(third);
    }
}
